/*
(c) Copyright 2008 Pacito.Sys hppacito@gmail.com

┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘

*/

#include <xs1.h>
#include <platform.h>
#include <stdio.h>

#include "vga_drv_cmd.h"
#include "xc_vga_drv.h"

core c[4];
char hstring[12] = "00000000";


void puthex(unsigned int x)
{
int i, j = 28, xx;
    for (i = 0; i < 8; i++, j -= 4)
    {
	xx = (x >> j) & 15;
	if (xx > 9)
	    hstring[i] = xx + 55;
	else
	    hstring[i] = '0'+xx;
    }
    puts(hstring);
}

void xc0_draw(chanend dchan)
{
unsigned int cmd, args[8], i, j;

    while (1)
    {
	dchan :> cmd;
	i = (cmd >> 8) & 7;
	for (j = 0; j < i; j++)
	    dchan :> args[j];
	cmd &= 255;
	c_vga_draw(cmd, args);
	//dchan <: 1;
    }
}

void xc1_control(chanend dchan);


int main( void ) on PLATFORM(c)
{
chan draw_channel;

    par
    {    
    	on c[0] : c_vga_refresh();
	on c[0] : xc0_draw(draw_channel);
	on c[1] : xc1_control(draw_channel);
    }
    
    return 0;
}

