/*
(c) Copyright 2008 Pacito.Sys hppacito@gmail.com

┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
*/

#include "vga_drv_defs.h"



// This code runs on x core 1

unsigned int arand( void );
    
void xc1_control(chanend dchan)
{
    dchan <: DCMD_CLRSCR; // clears screen
    
    dchan <: DCMD_LINE | (5<<8);
    dchan <: 0;
    dchan <: 0;
    dchan <: (XPIXELS - 1);
    dchan <: 0;
    dchan <: 1;

    dchan <: DCMD_LINE | (5<<8);
    dchan <: 0;
    dchan <: 0;
    dchan <: 0;
    dchan <: (YLINES - 1);
    dchan <: 1;

    dchan <: DCMD_LINE | (5<<8);
    dchan <: (XPIXELS - 1);
    dchan <: 0;
    dchan <: (XPIXELS - 1);
    dchan <: (YLINES - 1);
    dchan <: 1;

    dchan <: DCMD_LINE | (5<<8);
    dchan <: 0;
    dchan <: (YLINES - 1);
    dchan <: (XPIXELS - 1);
    dchan <: (YLINES - 1);
    dchan <: 1;
    
    while (1) // draws lines ohne ende
    {
	dchan <: DCMD_LINE | (5<<8);
	
	dchan <: 4 + arand() % (XPIXELS - 8);
	dchan <: 4 + arand() % (YLINES - 8);
	dchan <: 4 + arand() % (XPIXELS - 8);
	dchan <: 4 + arand() % (YLINES - 8);
	dchan <: arand() % 16;
    }
    
    while (1) // or can be pixels
    {
	dchan <: DCMD_PIXEL | (3<<8);
	
	dchan <: arand() % XPIXELS;
	dchan <: arand() % YLINES;
	dchan <: arand() % 16;
    }
}
